#include "GG_IOT.h"
#include <Arduino.h>

String GetHttpRespone(Client& Http_Client,int &_ggHttpCode,int &_ggContentLength) {
  int v,EndNumberPos;
  String line="",number_str;
  //Wait For Server Respone
  while(!Http_Client.available()) { delay(10); }
  //Read Respone Header
  while(Http_Client.available()) {
    v = Http_Client.read();
    if (v != -1)
    {
      line=line+(char)v;
    }
  }
#ifdef GG_IOT_DEBUG
  Serial.println(line);
#endif
  EndNumberPos=line.indexOf(" OK\r\n");
	_ggContentLength=0;
	if (EndNumberPos>0) {
		number_str=line.substring(EndNumberPos-3, EndNumberPos);
		_ggHttpCode=number_str.toInt();
		if (_ggHttpCode == 200) {	//HTTP/1.1正常回應
			v=line.indexOf("Content-Length:");
			EndNumberPos=line.indexOf("\r\n",v);
			number_str=line.substring(v+15, EndNumberPos);
			_ggContentLength=number_str.toInt();
#ifdef GG_IOT_DEBUG
			Serial.print("資料長度");
			Serial.println(_ggContentLength);
#endif
			v=line.indexOf("\r\n\r\n");
			if (v>0) {
				return line.substring(v+4, line.length());
			} else {	//伺服器回應內容不含資料
				return "";
			}
		} else {	//伺服器回應有錯誤發生
			return "";
		}
	} else {	//在預設時間內伺服器沒有回應
		_ggHttpCode=-1;
		return "";
	}
}

bool HttpGetRequest(Client &Http_Client,int &_ggHttpCode,HttpRequestHeader HttpHeader) {
	_ggHttpCode=-1;
	if (Http_Client.connect(HttpHeader.host.c_str(), HttpHeader.port)) {
		Http_Client.print("GET ");Http_Client.print(HttpHeader.url);Http_Client.println(" HTTP/1.1");
		Http_Client.print("Host: ");Http_Client.println(HttpHeader.host);
		if (HttpHeader.header.length()>0) {
			Http_Client.println(HttpHeader.header);
		}
		if (HttpHeader.UserAgent.length()>0) {
			Http_Client.print("User-Agent: ");
			Http_Client.println(HttpHeader.UserAgent);
		}
		if (HttpHeader.ContentType.length()>0) {
			Http_Client.print("Content-Type: ");
			Http_Client.println(HttpHeader.ContentType);
		}
		Http_Client.println("Content-Length: 0");
		Http_Client.println("Connection: close");
		Http_Client.println();
		return true;
  } else {
		return false;
	}
}

bool HttpPostRequest(Client &Http_Client,int &_ggHttpCode,HttpRequestHeader HttpHeader,String PostData) {
	_ggHttpCode=-1;
	if (Http_Client.connect(HttpHeader.host.c_str(), HttpHeader.port)) {
		Http_Client.print("POST ");Http_Client.print(HttpHeader.url);Http_Client.println(" HTTP/1.1");
		Http_Client.print("Host: ");Http_Client.println(HttpHeader.host);
		if (HttpHeader.header.length()>0) {
			Http_Client.println(HttpHeader.header);
		}
		if (HttpHeader.UserAgent.length()>0) {
			Http_Client.print("User-Agent: ");
			Http_Client.println(HttpHeader.UserAgent);
		}
		if (HttpHeader.ContentType.length()>0) {
			Http_Client.print("Content-Type: ");
			Http_Client.println(HttpHeader.ContentType);
		}
		Http_Client.print("Content-Length: ");
		Http_Client.println(PostData.length());
		Http_Client.println("Connection: close");
		Http_Client.println();
		Http_Client.print(PostData);
		Http_Client.println();	
		return true;
  } else {
		return false;
	}
}
