#include "GG_mcsRESTful.h"

csv4mcs Str2csv4mcs(String csv_str) {
  csv4mcs retval;
  int timepos=csv_str.indexOf(",");
  retval.id=csv_str.substring(0,timepos);
  int valpos=csv_str.lastIndexOf(",");
  retval.time=csv_str.substring(timepos+1,valpos);
  retval.data=csv_str.substring(valpos+1);
//csv_str.toFloat() csv_str.toInt() csv_str.toDouble()
  return retval;
}

mcsRESTful::mcsRESTful(String DeviceId,String DeviceKey) {
	ggDeviceId = DeviceId;
	ggDeviceKey = DeviceKey;
// MCS_API_Server = "api.mediatek.com";
// MCS_API_Port = 80;
}

mcsRESTful::mcsRESTful(String DeviceId,String DeviceKey,String host,int port) {
	ggLiteDeviceId = DeviceId;
	ggLiteDeviceKey = DeviceKey;
	MCS_Lite_Server = host;
	MCS_RS_Port = port;
}

int mcsRESTful::MCS_API_Get_Int(String DataChannelId) {
	String valueStr=MCS_API_Get(DataChannelId);
	return valueStr.toInt();
}

float mcsRESTful::MCS_API_Get_Float(String DataChannelId) {
	String valueStr=MCS_API_Get(DataChannelId);
	return valueStr.toFloat();
}

double mcsRESTful::MCS_API_Get_Double(String DataChannelId) {
	String valueStr=MCS_API_Get(DataChannelId);
	return valueStr.toDouble();
}

String mcsRESTful::MCS_API_Get(String DataChannelId) {
	csv4mcs csvdata;
	HttpRequestHeader ggMCS;
	String line="";
	
	ggMCS.host=MCS_API_Server;
	ggMCS.port=MCS_API_Port;
	ggMCS.url="/mcs/v2/devices/" + ggDeviceId + "/datachannels/" + DataChannelId + "/datapoints.csv";
	ggMCS.header="deviceKey: "+ggDeviceKey;
	ggMCS.UserAgent="";
	ggMCS.ContentType="text/csv";
	if (HttpGetRequest(ggmcs_client,mcsHttpCode,ggMCS)) {
		line=GetHttpRespone(ggmcs_client,mcsHttpCode,mcsContentLength);
	}
  ggmcs_client.stop();
	if (mcsHttpCode==200) {
		csvdata=Str2csv4mcs(line);
		return csvdata.data;
	} else {
		return line;
	}
}

bool mcsRESTful::MCS_API_Put(String DataChannelId,int DataChannelValue) {
	return MCS_API_Put(DataChannelId,String(DataChannelValue));
}

bool mcsRESTful::MCS_API_Put(String DataChannelId,long DataChannelValue) {
	return MCS_API_Put(DataChannelId,String(DataChannelValue));
}

bool mcsRESTful::MCS_API_Put(String DataChannelId,float DataChannelValue) {
	return MCS_API_Put(DataChannelId,String(DataChannelValue));
}

bool mcsRESTful::MCS_API_Put(String DataChannelId,double DataChannelValue) {
	return MCS_API_Put(DataChannelId,String(DataChannelValue));
}

bool mcsRESTful::MCS_API_Put(String DataChannelId,String DataChannelValue) {
	HttpRequestHeader ggMCS;
	String line="";
	
	ggMCS.host=MCS_API_Server;
	ggMCS.port=MCS_API_Port;
	ggMCS.url="/mcs/v2/devices/" + ggDeviceId + "/datapoints.csv";
	ggMCS.header="deviceKey: "+ggDeviceKey;
	ggMCS.UserAgent="";
	ggMCS.ContentType="text/csv";
  String payload=DataChannelId+",,"+DataChannelValue;
	if (HttpPostRequest(ggmcs_client,mcsHttpCode,ggMCS,payload)) {
		line=GetHttpRespone(ggmcs_client,mcsHttpCode,mcsContentLength);
	}
  ggmcs_client.stop();
	return mcsHttpCode==200;
}

int mcsRESTful::MCS_Lite_API_Get_Int(String DataChannelId) {
	String valueStr=MCS_Lite_API_Get(DataChannelId);
	return valueStr.toInt();
}

float mcsRESTful::MCS_Lite_API_Get_Float(String DataChannelId) {
	String valueStr=MCS_Lite_API_Get(DataChannelId);
	return valueStr.toFloat();
}

double mcsRESTful::MCS_Lite_API_Get_Double(String DataChannelId) {
	String valueStr=MCS_Lite_API_Get(DataChannelId);
	return valueStr.toDouble();
}

String mcsRESTful::MCS_Lite_API_Get(String DataChannelId) {
	csv4mcs csvdata;
	HttpRequestHeader ggMCSLite;
	String line="";
	
	ggMCSLite.host=MCS_Lite_Server;
	ggMCSLite.port=MCS_RS_Port;
	ggMCSLite.url="/api/devices/" + ggLiteDeviceId + "/datachannels/" + DataChannelId + "/datapoints.csv";
	ggMCSLite.header="deviceKey: "+ggLiteDeviceKey;
	ggMCSLite.UserAgent="";
	ggMCSLite.ContentType="text/csv";
	if (HttpGetRequest(ggmcs_client,mcsHttpCode,ggMCSLite)) {
		line=GetHttpRespone(ggmcs_client,mcsHttpCode,mcsContentLength);
	}
  ggmcs_client.stop();
	if (mcsHttpCode==200) {
		csvdata=Str2csv4mcs(line);
		return csvdata.data;
	} else {
		return line;
	}
}

bool mcsRESTful::MCS_Lite_API_Put(String DataChannelId,int DataChannelValue) {
	return MCS_Lite_API_Put(DataChannelId,String(DataChannelValue));
}

bool mcsRESTful::MCS_Lite_API_Put(String DataChannelId,long DataChannelValue) {
	return MCS_Lite_API_Put(DataChannelId,String(DataChannelValue));
}

bool mcsRESTful::MCS_Lite_API_Put(String DataChannelId,float DataChannelValue) {
	return MCS_Lite_API_Put(DataChannelId,String(DataChannelValue));
}

bool mcsRESTful::MCS_Lite_API_Put(String DataChannelId,double DataChannelValue) {
	return MCS_Lite_API_Put(DataChannelId,String(DataChannelValue));
}

bool mcsRESTful::MCS_Lite_API_Put(String DataChannelId,String DataChannelValue) {
	HttpRequestHeader ggMCSLite;
	String line="";
	
	ggMCSLite.host=MCS_Lite_Server;
	ggMCSLite.port=MCS_RS_Port;
	ggMCSLite.url="/api/devices/" + ggLiteDeviceId + "/datapoints.csv";
	ggMCSLite.header="deviceKey: "+ggLiteDeviceKey;
	ggMCSLite.UserAgent="";
	ggMCSLite.ContentType="text/csv";
  String payload=DataChannelId+",,"+DataChannelValue;
	if (HttpPostRequest(ggmcs_client,mcsHttpCode,ggMCSLite,payload)) {
		line=GetHttpRespone(ggmcs_client,mcsHttpCode,mcsContentLength);
	}
  ggmcs_client.stop();
	return mcsHttpCode==200;
}

int mcsRESTful::GetStatus() {
	return this->mcsHttpCode;
}
