#ifndef GG_mcsRESTful_h
#define GG_mcsRESTful_h

#include <Arduino.h>
#include "GG_IOT.h"

typedef struct {
	String id;
	String time;
	String data;
} csv4mcs;

class mcsRESTful
{
  public:

    mcsRESTful(String DeviceId,String DeviceKey,String host,int port);
    mcsRESTful(String DeviceId,String DeviceKey);
    
		String MCS_API_Get(String DataChannelId);
		int MCS_API_Get_Int(String DataChannelId);
		float MCS_API_Get_Float(String DataChannelId);
		double MCS_API_Get_Double(String DataChannelId);
    bool MCS_API_Put(String DataChannelId,int putdata);
    bool MCS_API_Put(String DataChannelId,long putdata);
    bool MCS_API_Put(String DataChannelId,float putdata);
    bool MCS_API_Put(String DataChannelId,double putdata);
    bool MCS_API_Put(String DataChannelId,String putdata);

    String MCS_Lite_API_Get(String DataChannelId);
    int MCS_Lite_API_Get_Int(String DataChannelId);
    float MCS_Lite_API_Get_Float(String DataChannelId);
    double MCS_Lite_API_Get_Double(String DataChannelId);
    bool MCS_Lite_API_Put(String DataChannelId,int putdata);
    bool MCS_Lite_API_Put(String DataChannelId,long putdata);
    bool MCS_Lite_API_Put(String DataChannelId,float putdata);
    bool MCS_Lite_API_Put(String DataChannelId,double putdata);
    bool MCS_Lite_API_Put(String DataChannelId,String putdata);
    int GetStatus();

  private:

	String ggDeviceId = "";
	String ggDeviceKey = "";

	String ggLiteDeviceId = "";
	String ggLiteDeviceKey = "";

	String MCS_Lite_Server = "192.168.32.9";
	String MCS_API_Server = "api.mediatek.com";

	int MCS_API_Port = 80;
	int MCS_RS_Port = 3000;
	int mcsHttpCode,mcsContentLength;
	
	WiFiClient ggmcs_client;
	
};

#endif