#include "GG_IOT.h"
#include "IFTTTWebhook.h"

IFTTTWebhook::IFTTTWebhook(String api_key) {
  _api_key = api_key;
	
#if defined(ESP32)
	IFTTT_client.setCACert(_iftt_rootCA.c_str());
#elif defined(ARDUINO_linkit_7697)
  IFTTT_client.setRootCA(_iftt_rootCA.c_str(), _iftt_rootCA.length());
#endif

}

String IFTTTWebhook::trigger(String event_name) {
  return IFTTTWebhook::trigger(event_name, "", "", "");
}

String IFTTTWebhook::trigger(String event_name,String value1) {
  return IFTTTWebhook::trigger(event_name, value1, "", "");
}

String IFTTTWebhook::trigger(String event_name,String value1, String value2) {
  return IFTTTWebhook::trigger(event_name, value1, value2, "");
}

String IFTTTWebhook::trigger(String event_name, String value1, String value2, String value3) {
	HttpRequestHeader ggIfttt;
	String line="";
	
	ggIfttt.host="maker.ifttt.com";
	ggIfttt.port=443;
	ggIfttt.url="https://maker.ifttt.com/trigger/" + event_name + "/with/key/" + _api_key;
	ggIfttt.header="";
	ggIfttt.UserAgent="BlocklyDuino/1.0";
	ggIfttt.ContentType="application/json;charset=utf-8";
	String payload = "{\"value1\":\"" + value1 + "\",\"value2\":\"" + value2 +"\",\"value3\":\"" + value3 + "\"}";
	if (HttpPostRequest(IFTTT_client,ifttHttpCode,ggIfttt,payload)) {
		line=GetHttpRespone(IFTTT_client,ifttHttpCode,ifttContentLength);
	}
	IFTTT_client.stop();
	return line;
}

int IFTTTWebhook::GetStatus() {
	return this->ifttHttpCode;
}